#!/bin/sh
##
##  freebsd-rc-upgrade.sh -- upgrade rc scripts from FreeBSD 4 to 5 format
##  Copyright (c) 2005 Ralf S. Engelschall <rse@engelschall.com>
##

for prefix in `cat /etc/openpkg`; do
    echo "OpenPKG instance $prefix"
    name=`echo "$prefix" | sed -e 's;/;;g'`
    if [ -f /etc/rc.d/$name.sh ] && [ ! -f /etc/rc.d/openpkg-$name ]; then
        echo "  UPGRADE: /etc/rc.d/$name.sh -> /etc/rc.d/openpkg-$name"
        ( echo "#!/bin/sh"
          echo "##"
          echo "##  openpkg-${name} -- startup/shutdown transfer script for OpenPKG ${prefix} hierarchy"
          echo "##"
          echo ""
          echo "# PROVIDE: openpkg-${name}"
          echo "# REQUIRE: LOGIN"
          echo "# KEYWORD: shutdown"
          echo ""
          echo ". /etc/rc.subr"
          echo ""
          echo "name=\"openpkg_${name}\""
          echo "start_cmd=\"openpkg_rc_all start\""
          echo "stop_cmd=\"openpkg_rc_all stop\""
          echo "restart_cmd=\"openpkg_rc_all stop start\""
          echo ""
          echo "openpkg_rc_all () {"
          echo "    if [ -f ${prefix}/etc/rc ]; then"
          echo "        ${prefix}/etc/rc all \"\$@\""
          echo "    fi"
          echo "}"
          echo ""
          echo "load_rc_config \$name"
          echo "run_rc_command \"\$1\""
          echo ""
        ) >/etc/rc.d/openpkg-$name
        chmod 755 /etc/rc.d/openpkg-$name
        rm -f /etc/rc.d/$name.sh
    fi
done

